# -*- coding: UTF-8 -*-

import clr

clr.AddReferenceByPartialName("System.Windows.Forms")
clr.AddReferenceByPartialName("System.Drawing")

from System import *
from System.IO import *
from System.Windows import *
from System.Windows.Forms import *
from System.Drawing import *

class NfIcon():
    """
        Task Tray Icon
    """
    def __init__(self):
        """
            Initialization
        """
        self.path = Path.GetDirectoryName(__file__)
        # create menu
        self.menu = ContextMenu()
        self.menu.MenuItems.Add("NotePad", self.on_notepad)
        self.menu.MenuItems.Add("Clipboard", self.on_clipboard)
        self.menu.MenuItems.Add("External file Execute", self.on_extern)
        self.menu.MenuItems.Add("-")
        self.menu.MenuItems.Add("Exit", self.on_exit)
        # create tray icon
        # Not inherit. this class is Sealed
        self.icon = NotifyIcon()
        self.icon.ContextMenu = self.menu
        self.icon.Icon = Icon(self.path + "\\icon.ico")
        self.icon.Text = "Description Text"
        self.icon.Visible = True

    def on_notepad(self, sender, e):
        """
            case Lancher
        """
        try:
            import os
            os.system("notepad.exe")
        except Exception, e:
            MessageBox.Show(e.Message)

    def on_clipboard(self, sender, e):
        """
            case Clipboard and Beep
        """
        try:
            Clipboard.SetText("Clipboard Text")
            Media.SystemSounds.Beep.Play()
        except Exception, e:
            MessageBox.Show(e.Message)

    def on_extern(self, sender, e):
        """
            case External file Execute
        """
        try:
            import extern
        except Exception, e:
            MessageBox.Show(e.Message)

    def on_exit(self, sender, e):
        """
            bye
        """
        self.icon.Visible = False
        Application.Exit()

if __name__ == "__main__":
    # Not Application.Run(NfIcon())
    NfIcon()
    Application.Run()